import processing.opengl.*;


import peasy.*;

PeasyCam cam;

int nr = 100;
int fw = 500;
int fh = 500;

int rows = 8;
int colums = 14; 
int tileW = 43;
int tileH = 43;
PVector [][] vertices;

PImage img;
void setup(){
  size(800,600,OPENGL);

  cam = new PeasyCam(this, 800);
  cam.setMinimumDistance(5);
  cam.setMaximumDistance(1000);

  img = loadImage("gridtex.png");

  vertices = new PVector[colums][rows];
  for(int i=0; i<colums; i++){
    for(int j=0; j<rows; j++){
      vertices[i][j] = new PVector(i*tileW,j*tileH,0);
    }
  }
}


void draw(){
  background(255);
  lights();
  drawGrid(10,10);
  drawCoords(10);
  textureMode(IMAGE);

  beginShape(QUADS);
  texture(img);
  for(int i=0; i<colums-1; i++){
    for(int j=0; j<rows-1; j++){
      vertex(vertices[i][j].x,vertices[i][j].y,vertices[i][j].z,i*tileW,j*tileH);
      vertex(vertices[i+1][j].x,vertices[i+1][j].y,vertices[i+1][j].z,(i+1)*tileW,j*tileH);
      vertex(vertices[i+1][j+1].x,vertices[i+1][j+1].y,vertices[i+1][j+1].z,(i+1)*tileW,(j+1)*tileH);
      vertex(vertices[i][j+1].x,vertices[i][j+1].y,vertices[i][j+1].z,i*tileW,(j+1)*tileH);
    }
  }
  endShape();
 

}






void drawGrid(float cells, float cellSide ){

  stroke(0);
  float w = cells*cellSide;
  pushMatrix();
  translate(-w/2,0,-w/2);
  for(int i=0; i<cells; i++){

    beginShape();
    vertex(i*cellSide,0,0);
    vertex(i*cellSide,0,cells*cellSide);
    endShape();
    //line(i*cellSide,0,i*cellSide,w*cellSide);

  }


  popMatrix();
  pushMatrix();
  translate(-w/2,0,-w/2);
  for(int j=0; j<cells; j++){
    beginShape();
    vertex(0,0,j*cellSide);
    vertex(cells*cellSide,0,j*cellSide);
    endShape();
  }
  popMatrix();

}


void drawCoords(float len){

  strokeWeight(3);
  stroke(0,0,255);
  beginShape(LINES);
  vertex(0,0,0);
  vertex(1*len,0*len,0*len);
  endShape();

  stroke(255,0,0);
  beginShape(LINES);
  vertex(0,0,0);
  vertex(0*len,1*len,0*len);
  endShape();

  stroke(0,255,0);
  beginShape(LINES);
  vertex(0,0,0);
  vertex(0*len,0*len,1*len);
  endShape();
  strokeWeight(1);
  stroke(0);

}






